Subject: [Sigtran] Multiple SCTP associations

From: "Sergey Mikhailov" <[email-masked]>
Date: Tue, 10 Jan 2006 19:39:26 +0300

Hi,

It seems that multiple SCTP associations established between the same two signaling processes are not [explicitly] prohibited.

1.
Is it legal for a signaling process to establish more than one SCTP association to the same AS/SG where these multiple associations are served by different signaling processes?

2.
Is it legal for a signaling process to establish more than one SCTP association to the same signaling process at the remote side?

(I feel that the 2nd case may be reasonable only when the remote side does not support multi-homed SCTP endpoints.)

Regards,
Sergey Mikhailov.

_______________________________________________
Sigtran mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/sigtran

---

From: "Tolga Asveren" <[email-masked]>
Date: Tue, 10 Jan 2006 11:33:06 -0500

Sergey,

-----Original Message-----
From: [email-masked] [mailto:[email-masked]]On Behalf Of
Sergey Mikhailov
Sent: Tuesday, January 10, 2006 11:39 AM
To: SIGTRAN
Subject: [Sigtran] Multiple SCTP associations

Hi,

It seems that multiple SCTP associations established between the same two
signaling processes are not [explicitly] prohibited.

1.
Is it legal for a signaling process to establish more than one SCTP
association to the same AS/SG where these multiple associations are served
by different signaling processes?
[TOLGA]Yes, this is how host redundancy is achieved (I assume you talk about
M3UA/SUA). There are multiple ASPs serving an AS, and multiple SGPs in a SG,
and there is a SCTP association between each SGP/ASP pair -well, obviously
it is not mandatory-.

2.
Is it legal for a signaling process to establish more than one SCTP
association to the same signaling process at the remote side?

(I feel that the 2nd case may be reasonable only when the remote side does
not support multi-homed SCTP endpoints.)
[TOLGA]Multiple SCTP assocaitions between two etities will have problems
with ASP state machine if you follow it strictly considering the state
transitions associated with events from SCTP. This is easy to overcome with
a some reasonable reinterpretation. OTOH, multiple SCTP associations won't
be a replacement for SCTP multihoming support because SCTP multihoming
provided network/NIC redundancy without loss/missequencing of messages.

Regards,
Sergey Mikhailov.

---

From: Ilie Glib <[email-masked]>
Date: Tue, 10 Jan 2006 18:16:07 +0100

Hello Sergey,

It is not possible to have two SCTP associations between two
Signalling processes by definition, since an association connects two
SCTP endpoints and a Signalling Process is characterized by its SCTP
endpoint. If you use another port number, or use dynamic port numbers
you get another Signalling Process.

It is possible that you have the same Signalling Process using
different SCTP endpoints during non-overlapping time periods, then the
Signalling Process shall identify itself via ASP_ID.

Tolga pointed it right, one consequence is that state machines will not work.

Пока, пока

Ilie

--
Ilie

---

From: "Sergey Mikhailov" <[email-masked]>
Date: Wed, 11 Jan 2006 12:19:29 +0300

Tolga, Ilie,
thank you for your valuable replies on the subject!

Please let me know, if I misinterpreted your answers.

1.
As far as I understand it, an SCTP endpoint, to say it strictly, may have 
only one SCTP association; and a signaling process may use multiple SCTP 
endpoints (and hence multiple SCTP associations) for communication with 
different signaling processes of one AS/SG.

2.
Multiple SCTP associations between the same two signaling processes, while 
not prohibited, will require reinterpretation of SCTP-to-ULP events (to keep 
communication status and ASP states consistent across multiple SCTP 
associations), such as NETWORK STATUS CHANGE, COMMUNICATION UP/LOST/ERROR, 
RESTART and SHUTDOWN COMPLETE events (RFC2960).

Regards,
Sergey Mikhailov.

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Wed, 11 Jan 2006 04:10:58 -0700

Sergey,

I am not agreeing with Tolga much lately...

It was never our intention to allow more than one SCTP association
between a given pair of processes to persist.

E.g. RFC 3332 1.3.2.4:

 ... In order to [sic] avoid redundant SCTP associations between two
 M3UA peers, one side (client) SHOULD be designated to establish the
 SCTP association, or M3UA configuration information established to
 detect redundant associations (e.g., via knowledge of the expected
 local and remote SCTP endpoint addresses).

This passage makes it clear that measures are to be taken to avoid
multiple associations.

Also, an ASP Identifier is required whenever multiple ASPs exist at
the same endpoint.  If the provided ASP Identifier is missing,
ERR("ASP Identifier Required") is returned to ASP Up.  If the ASP
Identifier is not unique, ERR("Invalid ASP Identifier") is returned
to ASP Up.  Therefore, multiple associations to the same ASP will not
allow ASP Up to proceed on all but one of them.

This is the same for both M3UA (RFC 3332 Section 3.8.1) and SUA
(RFC 3868 Section 3.9.12).

--brian

-- 
Brian F. G. Bidulock    ¦ The reasonable man adapts himself to the ¦
[email-masked]    ¦ world; the unreasonable one persists in  ¦
http://www.openss7.org/ ¦ trying  to adapt the  world  to himself. ¦
                        ¦ Therefore  all  progress  depends on the ¦
                        ¦ unreasonable man. -- George Bernard Shaw ¦

---

From: "Sergey Mikhailov" <[email-masked]>
Date: Wed, 11 Jan 2006 14:28:21 +0300

Brian,

Yes, I agree.
Thank you for pointing me to 1.3.2.4, now it seems clear.

Sergey Mikhailov.

----- Original Message ----- 
From: "Brian F. G. Bidulock" <[email-masked]>
To: "Sergey Mikhailov" <[email-masked]>
Cc: <[email-masked]>; <[email-masked]>; "SIGTRAN" 
<[email-masked]>
Sent: Wednesday, January 11, 2006 2:10 PM
Subject: Re: [Sigtran] Multiple SCTP associations

>> > From: [email-masked] [mailto:[email-masked]]On 
>> > Behalf
>> > Of
>> > Sergey Mikhailov
>> > M3UA/SUA). There are multiple ASPs serving an AS, and multiple SGPs in 
>> > a
>> > SG,

---

From: Ilie Glib <[email-masked]>
Date: Wed, 11 Jan 2006 13:04:25 +0100

Sergey,

On 1/11/06, Sergey Mikhailov <[email-masked]> wrote:
> only one SCTP association;

[Ilie] An SCTP endpoint may have at most one association towards
another SCTP endpoint. The SCTP association is a couple of SCTP
endpoints.
An SCTP endpoint can be an endpoint of multiple SCTP associations.

Regards

--
Ilie

---

From: "Sergey Mikhailov" <[email-masked]>
Date: Wed, 11 Jan 2006 15:45:58 +0300

Thanks, Ilie.

Regards,
Sergey Mikhailov.

---

From: "Tolga Asveren" <[email-masked]>
Date: Wed, 11 Jan 2006 07:49:16 -0500

Sergey,

> From: Sergey Mikhailov [mailto:[email-masked]]
> Sent: Wednesday, January 11, 2006 4:19 AM
> To: [email-masked]; [email-masked]
> Cc: SIGTRAN
[TOLGA]Yes.
> RESTART and SHUTDOWN COMPLETE events (RFC2960).
[TOLGA]The protocol never intends to use multiple associations between two
signaling entities. If you follow that path -for some reason-, both sides
will need to agree on the chneges necessary to support that scenario, i.e.
it won't be a solution compliant with the protocol.
> > From: [email-masked]
[mailto:[email-masked]]On Behalf

---

From: "Tolga Asveren" <[email-masked]>
Date: Wed, 11 Jan 2006 08:03:42 -0500

one correction below...

> [mailto:[email-masked]]On Behalf Of Tolga Asveren
> Sent: Wednesday, January 11, 2006 7:49 AM
> To: [email-masked]
[TOLGA]Actually no. Each signaling process is an SCTP endpoint. You have
different SCTP associations from this endpoint to different SCTP endpoints.

SCTP endpoint ==> local IP addresses, port
SCTP association ==> A relationship between two SCTP endpoints

---

From: "Sergey Mikhailov" <[email-masked]>
Date: Wed, 11 Jan 2006 16:48:29 +0300

Tolga,
some comments below.

> different SCTP associations from this endpoint to different SCTP 

[Sergey] Ok, now I'm agree.

> SCTP endpoint ==> local IP addresses, port

[Sergey] I would consider an SCTP endpoint this way:
SCTP endpoint ==> combination of a set of destination transport addresses 
and a set of source transport addresses (see SCTP endpoint definition on 
Page 13 of the RFC 2960).

> SCTP association ==> A relationship between two SCTP endpoints

[Sergey] Agree.

>> it won't be a solution compliant with the protocol.

[Sergey] Ok.

Regards,
Sergey Mikhailov.